{
    "$graph": [
        {
            "class": "Workflow",
            "id": "#bam2fasta.cwl",
            "label": "bam2fasta",
            "requirements": [],
            "inputs": [
                {
                    "type": "File",
                    "id": "#bam2fasta.cwl/bam2fasta/bam"
                },
                {
                    "type": "File",
                    "id": "#bam2fasta.cwl/bam2fasta/fasta"
                },
                {
                    "type": "int",
                    "default": 4,
                    "id": "#bam2fasta.cwl/bam2fasta/threads"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/fasta",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_consensus/ref_fasta"
                        },
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/bcftools_index_after_qc/indexed",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_consensus/vcf"
                        }
                    ],
                    "out": [
                        "#bam2fasta.cwl/bam2fasta/bcftools_consensus/out_fasta"
                    ],
                    "run": "#bcftools-consensus.cwl",
                    "id": "#bam2fasta.cwl/bam2fasta/bcftools_consensus"
                },
                {
                    "in": [
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/bcftools_norm/normalized_bcf",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_index_after_normalization/bcf"
                        }
                    ],
                    "out": [
                        "#bam2fasta.cwl/bam2fasta/bcftools_index_after_normalization/indexed"
                    ],
                    "run": "#bcftools-index.cwl",
                    "id": "#bam2fasta.cwl/bam2fasta/bcftools_index_after_normalization"
                },
                {
                    "in": [
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/bcftools_view_qc/vcf",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_index_after_qc/bcf"
                        }
                    ],
                    "out": [
                        "#bam2fasta.cwl/bam2fasta/bcftools_index_after_qc/indexed"
                    ],
                    "run": "#bcftools-index.cwl",
                    "id": "#bam2fasta.cwl/bam2fasta/bcftools_index_after_qc"
                },
                {
                    "in": [
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/bcftools_view_exclude_ref/bcf",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_norm/bcf"
                        },
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/fasta",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_norm/ref_fasta"
                        },
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/threads",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_norm/threads"
                        }
                    ],
                    "out": [
                        "#bam2fasta.cwl/bam2fasta/bcftools_norm/normalized_bcf"
                    ],
                    "run": "#bcftools-norm.cwl",
                    "id": "#bam2fasta.cwl/bam2fasta/bcftools_norm"
                },
                {
                    "in": [
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/threads",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_view_exclude_ref/threads"
                        },
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/freebayes/vcf",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_view_exclude_ref/vcf"
                        }
                    ],
                    "out": [
                        "#bam2fasta.cwl/bam2fasta/bcftools_view_exclude_ref/bcf"
                    ],
                    "run": "#bcftools-view-exclude-ref.cwl",
                    "id": "#bam2fasta.cwl/bam2fasta/bcftools_view_exclude_ref"
                },
                {
                    "in": [
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/bcftools_index_after_normalization/indexed",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_view_qc/bcf"
                        },
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/threads",
                            "id": "#bam2fasta.cwl/bam2fasta/bcftools_view_qc/threads"
                        }
                    ],
                    "out": [
                        "#bam2fasta.cwl/bam2fasta/bcftools_view_qc/vcf"
                    ],
                    "run": "#bcftools-view-qc.cwl",
                    "id": "#bam2fasta.cwl/bam2fasta/bcftools_view_qc"
                },
                {
                    "in": [
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/bam",
                            "id": "#bam2fasta.cwl/bam2fasta/freebayes/bam"
                        },
                        {
                            "source": "#bam2fasta.cwl/bam2fasta/fasta",
                            "id": "#bam2fasta.cwl/bam2fasta/freebayes/ref_fasta"
                        }
                    ],
                    "out": [
                        "#bam2fasta.cwl/bam2fasta/freebayes/vcf"
                    ],
                    "run": "#freebayes.cwl",
                    "id": "#bam2fasta.cwl/bam2fasta/freebayes"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#bam2fasta.cwl/bam2fasta/bcftools_consensus/out_fasta",
                    "id": "#bam2fasta.cwl/bam2fasta/out_fasta"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "quay.io/biocontainers/bcftools:1.10.2--hd2cd319_0",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "bcftools",
            "arguments": [
                "consensus",
                "-i'QUAL > 1 && GT=\"A\"'",
                "-Hla",
                "-f",
                "$(inputs.ref_fasta)",
                "$(inputs.vcf)"
            ],
            "inputs": [
                {
                    "id": "#bcftools-consensus.cwl/ref_fasta",
                    "type": "File"
                },
                {
                    "id": "#bcftools-consensus.cwl/vcf",
                    "type": "File",
                    "secondaryFiles": [
                        {
                            "pattern": ".csi",
                            "required": null
                        }
                    ]
                }
            ],
            "outputs": [
                {
                    "id": "#bcftools-consensus.cwl/out_fasta",
                    "type": "File",
                    "outputBinding": {
                        "glob": "sequence.fasta"
                    }
                }
            ],
            "stdout": "sequence.fasta",
            "id": "#bcftools-consensus.cwl"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "quay.io/biocontainers/bcftools:1.10.2--hd2cd319_0",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        "$(inputs.bcf)"
                    ],
                    "class": "InitialWorkDirRequirement"
                }
            ],
            "baseCommand": "bcftools",
            "arguments": [
                "index",
                "$(inputs.bcf)"
            ],
            "inputs": [
                {
                    "id": "#bcftools-index.cwl/bcf",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#bcftools-index.cwl/indexed",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bcf.basename)"
                    },
                    "secondaryFiles": [
                        {
                            "pattern": ".csi",
                            "required": null
                        }
                    ]
                }
            ],
            "id": "#bcftools-index.cwl"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "quay.io/biocontainers/bcftools:1.10.2--hd2cd319_0",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "bcftools",
            "arguments": [
                "norm",
                "-Ob",
                "-f",
                "$(inputs.ref_fasta)",
                "-o",
                "$(inputs.output_name)",
                "--threads",
                "$(inputs.threads)",
                "$(inputs.bcf)"
            ],
            "inputs": [
                {
                    "id": "#bcftools-norm.cwl/ref_fasta",
                    "type": "File"
                },
                {
                    "id": "#bcftools-norm.cwl/output_name",
                    "type": "string",
                    "default": "normalized.bcf"
                },
                {
                    "id": "#bcftools-norm.cwl/threads",
                    "type": "int"
                },
                {
                    "id": "#bcftools-norm.cwl/bcf",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#bcftools-norm.cwl/normalized_bcf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    }
                }
            ],
            "id": "#bcftools-norm.cwl"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "quay.io/biocontainers/bcftools:1.10.2--hd2cd319_0",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "bcftools",
            "arguments": [
                "view",
                "--no-version",
                "-Ou",
                "-e'type=ref'",
                "--threads=$(inputs.threads)",
                "$(inputs.vcf)"
            ],
            "inputs": [
                {
                    "id": "#bcftools-view-exclude-ref.cwl/vcf",
                    "type": "File"
                },
                {
                    "id": "#bcftools-view-exclude-ref.cwl/threads",
                    "type": "int"
                }
            ],
            "outputs": [
                {
                    "id": "#bcftools-view-exclude-ref.cwl/bcf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.vcf.nameroot).without-ref.bcf"
                    }
                }
            ],
            "stdout": "$(inputs.vcf.nameroot).without-ref.bcf",
            "id": "#bcftools-view-exclude-ref.cwl"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "quay.io/biocontainers/bcftools:1.10.2--hd2cd319_0",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "bcftools",
            "arguments": [
                "view",
                "-i",
                "QUAL>1 && (GT=\"AA\" || GT=\"Aa\")",
                "-Oz",
                "--threads=$(inputs.threads)",
                "$(inputs.bcf)"
            ],
            "inputs": [
                {
                    "id": "#bcftools-view-qc.cwl/threads",
                    "type": "int"
                },
                {
                    "id": "#bcftools-view-qc.cwl/bcf",
                    "type": "File",
                    "secondaryFiles": [
                        {
                            "pattern": ".csi",
                            "required": null
                        }
                    ]
                }
            ],
            "outputs": [
                {
                    "id": "#bcftools-view-qc.cwl/vcf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "out.changes.vcf.gz"
                    }
                }
            ],
            "stdout": "out.changes.vcf.gz",
            "id": "#bcftools-view-qc.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "string",
            "requirements": [
                {
                    "dockerPull": "quay.io/biocontainers/bwa:0.7.17--h84994c4_5",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": [
                "bwa",
                "mem"
            ],
            "inputs": [
                {
                    "type": "File",
                    "label": "input fastq file to map (single-end or forward for pair-end)",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#bwa-mem.cwl/fastq_forward"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "label": "input fastq file to map (reverse for pair-end)",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#bwa-mem.cwl/fastq_reverse"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "label": "read group header line such as '@RG\tID:foo\tSM:bar'",
                    "inputBinding": {
                        "prefix": "-R"
                    },
                    "id": "#bwa-mem.cwl/group_header_line"
                },
                {
                    "type": "File",
                    "label": "fasta file for index basename",
                    "inputBinding": {
                        "position": 1
                    },
                    "secondaryFiles": [
                        {
                            "pattern": ".amb",
                            "required": null
                        },
                        {
                            "pattern": ".ann",
                            "required": null
                        },
                        {
                            "pattern": ".bwt",
                            "required": null
                        },
                        {
                            "pattern": ".pac",
                            "required": null
                        },
                        {
                            "pattern": ".sa",
                            "required": null
                        }
                    ],
                    "id": "#bwa-mem.cwl/index_base"
                },
                {
                    "type": "string",
                    "label": "sam file to output results to",
                    "default": "out.sam",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#bwa-mem.cwl/output_sam"
                },
                {
                    "type": "int",
                    "label": "number of threads",
                    "default": 4,
                    "inputBinding": {
                        "prefix": "-t"
                    },
                    "id": "#bwa-mem.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_sam)"
                    },
                    "id": "#bwa-mem.cwl/output"
                },
                {
                    "type": "File",
                    "id": "#bwa-mem.cwl/stderr",
                    "outputBinding": {
                        "glob": "bwa-mem-stderr.log"
                    }
                },
                {
                    "type": "File",
                    "id": "#bwa-mem.cwl/stdout",
                    "outputBinding": {
                        "glob": "bwa-mem-stdout.log"
                    }
                }
            ],
            "stdout": "bwa-mem-stdout.log",
            "stderr": "bwa-mem-stderr.log",
            "id": "#bwa-mem.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "hints": [
                {
                    "ramMin": 3000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/fastq_forward"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/fastq_reverse"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/metadata"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        {
                            "pattern": ".amb",
                            "required": null
                        },
                        {
                            "pattern": ".ann",
                            "required": null
                        },
                        {
                            "pattern": ".bwt",
                            "required": null
                        },
                        {
                            "pattern": ".pac",
                            "required": null
                        },
                        {
                            "pattern": ".sa",
                            "required": null
                        },
                        {
                            "pattern": ".fai",
                            "required": null
                        }
                    ],
                    "id": "#main/ref_fasta"
                },
                {
                    "type": "int",
                    "default": 4,
                    "id": "#main/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/bam2fasta/out_fasta",
                    "id": "#main/out_fasta"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/metadata",
                    "id": "#main/out_metadata"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#main/samtools-sort/sorted_bam",
                            "id": "#main/bam2fasta/bam"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/bam2fasta/fasta"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/bam2fasta/threads"
                        }
                    ],
                    "out": [
                        "#main/bam2fasta/out_fasta"
                    ],
                    "run": "#bam2fasta.cwl",
                    "id": "#main/bam2fasta"
                },
                {
                    "in": [
                        {
                            "source": "#main/fastq_forward",
                            "id": "#main/bwa-mem/fastq_forward"
                        },
                        {
                            "source": "#main/fastq_reverse",
                            "id": "#main/bwa-mem/fastq_reverse"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/bwa-mem/index_base"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/bwa-mem/threads"
                        }
                    ],
                    "out": [
                        "#main/bwa-mem/output"
                    ],
                    "run": "#bwa-mem.cwl",
                    "id": "#main/bwa-mem"
                },
                {
                    "in": [
                        {
                            "source": "#main/samtools-view/bam",
                            "id": "#main/samtools-sort/input_bamfile"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/samtools-sort/threads"
                        }
                    ],
                    "out": [
                        "#main/samtools-sort/sorted_bam"
                    ],
                    "run": "#samtools-sort.cwl",
                    "id": "#main/samtools-sort"
                },
                {
                    "in": [
                        {
                            "source": "#main/bwa-mem/output",
                            "id": "#main/samtools-view/input_file"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/samtools-view/threads"
                        }
                    ],
                    "out": [
                        "#main/samtools-view/bam"
                    ],
                    "run": "#samtools-view.cwl",
                    "id": "#main/samtools-view"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "quay.io/biocontainers/freebayes:1.3.2--py37hc088bd4_0",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "freebayes",
            "arguments": [
                "--bam",
                "$(inputs.bam)",
                "--ploidy",
                "1",
                "-f",
                "$(inputs.ref_fasta)"
            ],
            "inputs": [
                {
                    "id": "#freebayes.cwl/bam",
                    "type": "File"
                },
                {
                    "id": "#freebayes.cwl/ref_fasta",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#freebayes.cwl/vcf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "var.vcf"
                    }
                }
            ],
            "stdout": "var.vcf",
            "id": "#freebayes.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "samtools sort, sort given bam file",
            "requirements": [
                {
                    "dockerPull": "quay.io/biocontainers/samtools:1.9--h8571acd_11",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": [
                "samtools",
                "sort"
            ],
            "inputs": [
                {
                    "type": "File",
                    "label": "Input bamfile",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#samtools-sort.cwl/input_bamfile"
                },
                {
                    "type": "string",
                    "default": "aln.sorted.bam",
                    "label": "Write final output to FILENAME",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#samtools-sort.cwl/output_bam"
                },
                {
                    "type": "int",
                    "default": 4,
                    "inputBinding": {
                        "prefix": "-@"
                    },
                    "id": "#samtools-sort.cwl/threads"
                },
                {
                    "type": "string",
                    "default": "sort.tmp",
                    "label": "Write temporary files to PREFIX.nnnn.bam",
                    "inputBinding": {
                        "prefix": "-T"
                    },
                    "id": "#samtools-sort.cwl/tmpfile"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_bam)"
                    },
                    "id": "#samtools-sort.cwl/sorted_bam"
                },
                {
                    "type": "File",
                    "id": "#samtools-sort.cwl/stderr",
                    "outputBinding": {
                        "glob": "samtools-sort-stderr.log"
                    }
                },
                {
                    "type": "File",
                    "id": "#samtools-sort.cwl/stdout",
                    "outputBinding": {
                        "glob": "samtools-sort-stdout.log"
                    }
                }
            ],
            "stdout": "samtools-sort-stdout.log",
            "stderr": "samtools-sort-stderr.log",
            "id": "#samtools-sort.cwl",
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "doc": "samtools view to convert sam format to bam format",
            "requirements": [
                {
                    "dockerPull": "quay.io/biocontainers/samtools:1.9--h8571acd_11",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": [
                "samtools",
                "view"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "label": "Do not output alignments with any bits set in INT present in the FLAG field. INT can be specified in hex by beginning with `0x' (i.e. /^0x[0-9A-F]+/) or in octal by beginning with `0' (i.e. /^0[0-7]+/) [0].",
                    "inputBinding": {
                        "prefix": "-F"
                    },
                    "id": "#samtools-view.cwl/filter_alignments"
                },
                {
                    "type": "boolean",
                    "label": "ignored for compatibility with previous samtools versions",
                    "default": false,
                    "inputBinding": {
                        "prefix": "-S"
                    },
                    "id": "#samtools-view.cwl/ignore_previous_version"
                },
                {
                    "type": "boolean",
                    "label": "include the header in the output",
                    "default": false,
                    "inputBinding": {
                        "prefix": "-h"
                    },
                    "id": "#samtools-view.cwl/include_header"
                },
                {
                    "type": "File",
                    "label": "input file",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#samtools-view.cwl/input_file"
                },
                {
                    "type": "boolean",
                    "label": "output BAM",
                    "default": true,
                    "inputBinding": {
                        "prefix": "-b"
                    },
                    "id": "#samtools-view.cwl/output_bam"
                },
                {
                    "type": "string",
                    "label": "output file name",
                    "default": "aln.bam",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#samtools-view.cwl/output_filename"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "label": "Skip alignments with MAPQ smaller than INT [0].",
                    "inputBinding": {
                        "prefix": "-q"
                    },
                    "id": "#samtools-view.cwl/skip_alignments"
                },
                {
                    "type": "int",
                    "label": "Number of additional threads to use",
                    "default": 4,
                    "inputBinding": {
                        "prefix": "-@"
                    },
                    "id": "#samtools-view.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_filename)"
                    },
                    "id": "#samtools-view.cwl/bam"
                },
                {
                    "type": "File",
                    "id": "#samtools-view.cwl/stderr",
                    "outputBinding": {
                        "glob": "samtools-view-stderr.log"
                    }
                },
                {
                    "type": "File",
                    "id": "#samtools-view.cwl/stdout",
                    "outputBinding": {
                        "glob": "samtools-view-stdout.log"
                    }
                }
            ],
            "stdout": "samtools-view-stdout.log",
            "stderr": "samtools-view-stderr.log",
            "id": "#samtools-view.cwl",
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                }
            ]
        }
    ],
    "cwlVersion": "v1.1"
}
